<template>
    <div>
        <crumbs title="条目关联质控类型">
            <el-form :inline="true" class="demo-form-inline">
                <el-form-item label="所属医院：">
                    <el-select size="mini" v-model.trim="filter.hospitalId" @change="getValue"  placeholder="所属医院" clearable>
                        <el-option v-for="item in hospitalList" :label="item.name" :value="item.val" :key="item.id" ></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="质控类型：">
                    <el-select size="mini" v-model.trim="filter.typeName" placeholder="质控类型" clearable>
                        <el-option v-for="item in qcTypeNameList" :label="item.name" :value="item.name" :key="item.name" ></el-option>
                    </el-select>
                </el-form-item>
                 <el-form-item label="条目名称：">
                    <el-input size="mini" v-model.trim="filter.entryName" placeholder="条目名称" clearable></el-input>
                </el-form-item>
                <el-form-item label="所属模块：">
                     <el-select size="mini" v-model.trim="filter.casesId"  placeholder="所属模块" clearable>
                        <el-option v-for="item in moduleList" :label="item.name" :value="item.id" :key="item.id" ></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="条目编码：">
                    <el-input size="mini" v-model.trim="filter.code" placeholder="条目编码" clearable></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                    <!-- <el-button size="mini" type="warning" @click="addTemp">添加模板</el-button> -->
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents">
            <el-table
                    :data="list"
                    border
                    style="width: 100%">
                <el-table-column
                    type="index"
                    :index="indexMethod"
                    label="编号"
                    width="60">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        label="所属医院"
                        prop="hospitalId"
                        :formatter="hisFormatter"
                        >
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="entryName"
                        label="条目名称"
                        width="180"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="casesName"
                        label="所属模块">
                </el-table-column>
                
                <el-table-column
                        :resizable = "false"
                        prop="code"
                        label="条目编码">
                </el-table-column>
                 <el-table-column
                        :resizable = "false"
                        prop="typeStr"
                        label="质控类型"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="operate"
                        label="操作">
                    <template slot-scope="scope">
                        <el-button  @click="modifyIndeptTag(scope.row, 'modify')" type="text" size="small">关联</el-button>
                        <!-- <span style="margin:0 3px;">|</span>
                        <el-button @click="modifyIndeptTag(scope.row, 'copy')" class="text" type="text" size="small">复制</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button @click="showDelDialog(scope.row)" class="delete" type="text" size="small">删除</el-button> -->
                    </template>
                </el-table-column>
            </el-table>
          <el-pagination  :current-page.sync="currentPage"
                          @current-change="currentChange"
                          background
                          :page-size.sync="pageSize"
                          :page-sizes="pageSizeArr"
                           @size-change="handleSizeChange"
                          :layout="pageLayout"
                          :total="total">
            </el-pagination>
        </div>
    </div>
</template>

<script>
  import api from '@api/qualityControl.js';
  import apis from '@api/records.js';
  import config from '@api/config.js';
  import utils from '@api/utils.js'
  export default {
    name: 'ItemDataType',
    data: function() {
      return {
        list: [],
        hospitalList: [],
        moduleList:[],
        qcTypeNameList:[],
        searched: false,
        filter: {
          typeName:"",//质控类型名称
          hospitalId: "", //所属医院
          entryName:"", //条目名称
          casesId:null,//所属模块
          code:"",//条目编码
        },
        currentPage: 1,
        pageSize: config.pageSize,
        pageSizeArr:config.pageSizeArr,
        pageLayout:config.pageLayout,
        total: 0,
      }
    },
    created() {
      const _this=this;
      this.getTypeNameList()
      this.getModuleList()
      setTimeout(function(){
        _this.getAllTypes().then(()=>{
          _this.getDataList()
        })
      },100);

    },
    watch: {
      'filter': {
        handler: function () {
          this.searched = false;
        },
        deep: true
      }
    },
    beforeRouteEnter(to, from, next) {
      next(vm => {
        //const pm = to.param;
        Object.assign(vm, to.params);
        vm.inCurrentPage=to.params.currentPage;
      })
    },
    methods: {
      moduleFormatter(row, column, cellValue){
        const it = this.moduleList.find(item => item.id == cellValue);
        return it?it.name:'';
      },
      hisFormatter(row, column, cellValue){
        const it = this.hospitalList.find(item => item.val == cellValue);
        return it?it.name:'';
      },
      getAllTypes(){
          /*if(localStorage.getItem("qcModuleTypes")){
              this.hospitalList = JSON.parse(localStorage.getItem("qcHospitalTypes"));
              return new Promise(function(resolve, reject){
                  resolve()
              });
          }*/
          //获取枚举信息
          return api.getQcTypes().then((res)=>{
              if(res.data.code==="0"){
                  const data = res.data.data;
                    this.hospitalList =data[13];
                  /*localStorage.setItem("qcFieldTypes",JSON.stringify(data[11]));
                  localStorage.setItem("qcModuleTypes",JSON.stringify(data[12]));
                  localStorage.setItem("qcHospitalTypes",JSON.stringify(data[13]));
                  this.hospitalList = JSON.parse(localStorage.getItem("qcHospitalTypes"));*/
              }else{
                  this.warning("获取枚举信息失败");
              }
          });
      },
      
      getTypeNameList(hospitalId){
        api.getQcEntryTypeByHospital({hospitalId:hospitalId}).then((res) => {
          if(res.data.code == 0){
            // let list = res.data.data.records
              this.qcTypeNameList = res.data.data
              this.qcTypeNameList.unshift({id: null, name:"无质控类型"})
          }
          
        })
      },
       getModuleList(){
        return apis.getRecordCases({}).then((res)=>{
          const result = res.data;
          if(result.code==0){
            this.moduleList = result.data
          }else{
            this.$message({
              message:result.msg,
              type:'warning',
              showClose: true
            });
          }
        })
      },
      handleSizeChange(val){
        this.pageSize = val;
        this.currentPage = utils.getCurrentPage(this.currentPage, this.total, this.pageSize);
        this.getDataList();
      },
      getValue(val) {
        this.filter.typeName = ""
        this.qcTypeNameList=[]
        this.getTypeNameList(val)
      },
      getDataList(isTurnPage) {
        const param = this.getFilterItems(isTurnPage);
        this.searched = true;
        const loading = this.$loading({
            lock: true,
            text: 'Loading',
            spinner: 'el-icon-loading',
            background: 'rgba(0, 0, 0, 0.7)'
        });
        api.getQcEntryTypeList(param).then((res) => {
          loading.close()
          if(res.data.code == 0){
            let list = res.data.data.records
          /*for(let i = 0; i < list.length; i++){
            list[i].hospitalId = this.hospitalList.find(item => item.val == list[i].hospitalId).name
            list[i].modeId  = this.moduleList.find(item => item.val == list[i].modeId).name
          }*/
          this.list = list;
          this.total = res.data.data.total;
          if(this.inCurrentPage!==undefined){
            this.currentPage=this.inCurrentPage;
            this.inCurrentPage = undefined;
          }
          }
          
        })
      },
      filterDatas() {
        this.currentPage = 1;
        this.getDataList();
      },
      addTemp() {
        const pam = this.searched ? {
          currentPage: this.currentPage,
          pageSize:this.pageSize,
          filter: this.filter
        } : {currentPage: this.currentPage,pageSize:this.pageSize};
        this.$router.push({
          name: 'ItemDataTypeRelation',
          params: pam
        })
      },
      modifyIndeptTag(row, type) {
        api.getQcEntryTypeDetail({ "entryId": row.entryId,"hospitalId": row.hospitalId}).then((res)=>{
          const {code,data,msg} = res.data;
          const hospitalItem = this.hospitalList.find(item => item.val == row.hospitalId);
         const hospitalName = hospitalItem ? hospitalItem.name:''
          if(code=='0'){
            const item = Object.assign({},{hospitalName:hospitalName},data);
            const pam = this.searched ? {
              currentPage: this.currentPage,
              filter: this.filter
            } : {currentPage: this.currentPage};
            if(type == 'modify') {
              this.$router.push({name: 'ItemDataTypeRelation', params: Object.assign(pam, {isEdit: true, data: item})});
            } else if( type == 'copy') {
              this.$router.push({name: 'ItemDataTypeRelation', params: Object.assign(pam, {isCopy: true, data: item})});
            } else {
                return
            }
          }else{
            this.$message({
              message: msg,
              type: 'warning'
            });
          }
        });
        //this.$router.push({name:'AddIndeptLabel',params:{isEdit:true,data:row}});
      },
      currentChange(next) {
        this.currentPage = next;
        this.getDataList(true);
        // if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
        //     this.list = this.cacheData[next];
        // } else {
        //     this.getDataList();
        // }
      },
      clearFilter(){
        this.filter={
          hospitalId: "",
          typeName:"",
          entryName:"",
          casesId:null,
          code:""
        };
      },
      getFilterItems(isTurnPage) {
        //翻页时筛选条件没点确定则清空
        if(isTurnPage&&!this.searched){
          this.clearFilter();
        };
        const {hospitalId,typeName,entryName,casesId,code} = this.filter
        let param = {
          current: this.inCurrentPage||this.currentPage,
          size: this.pageSize,
          hospitalId: hospitalId,
          typeName:typeName,
          entryName:entryName,
          casesId:casesId,
          code:code
        };
        if(typeName == "无质控类型"){
          param = Object.assign({}, param,{typeName:"",typeIsNull:1})
        }
        return param;
      },
      indexMethod(index) {
        return ((this.currentPage - 1) * this.pageSize) + index + 1;
      },
      getTagType(val) {
        return val
      },
      warning(msg,type){
        this.$message({
          showClose: true,
          dangerouslyUseHTMLString: true,
          message:'<p>'+msg+'</p>',
          type:type||'warning'
        })
      },
      showConfirmDialog(msg,resolve){
        this.$alert(msg, '提示', {
          confirmButtonText: '确定',
          type: 'warning'
        }).then(() => {
          resolve();
        }).catch(() => {});
      },
      showDelDialog(row){
        const param = {
          "ids": row.id,
        }
        this.showConfirmDialog('是否删除该模板？',()=>{
          api.delQCTemp(param).then((res)=>{
            if(res.data.code=='0'){
              if(!this.searched){
                //未点确认时清空搜索条件
                this.clearFilter();
              }
              if(this.list.length==1){
                //当前在最后一页且只有一条数据时，删除后跳到前一页
                this.currentPage = this.currentPage===1?1:this.currentPage-1;
              }
              this.getDataList();
              this.warning(res.data.msg || '操作成功','success');
            }else{
              this.warning(res.data.msg);
            }
          }).catch((error)=>{
            this.warning(error);
          })
        });
      }
    }
  }
</script>


<style lang="less">
  @import "../../less/admin.less";
    .delete{
        color: red
    }
    .delete:hover {
        color: red;
    }
    .el-select .el-input .el-icon-arrow-up{
        display: inline-block!important;
    }
    .el-select .el-input .el-icon-circle-close{
        float:left;
    }
  .el-pagination__sizes{
      margin-right: 20px;
    .el-input .el-input__inner{
        height: 28px;
        line-height: 28px;
    }
  }
</style>